<%@  Language=JavaScript %>
<!-- #include file="../Common/Odbc.asp" -->
<!-- #include file="../Common/Tools.asp" -->
<SCRIPT LANGUAGE=javascript RUNAT=Server>
/*****************************************************
* $Revision: 58 $
*   $Author: Nathalih $
*     $Date: 30/07/01 10:14 $
******************************************************/
</SCRIPT>
<SCRIPT LANGUAGE=javascript RUNAT=Server>
var User, db_password, nt_user = 0, level;
var RSUtilisateur, RSGroup, RSProfil, RSProfUsr, RSToutServ, IDUSER;
var RSSession, strFilter, UserDN;
var bNTUser, bLDAPUser, bDName, bAuthenticate;
var AUserInfos,AGroupInfos;
//**********************************************************************//
// NAME Init															//
//                                                                      //
// DESCRIPTION                                                          //
//   Initialisation de l'appli depuis la table							//
//   VDX_PRODUIT                                                        //
//                                                                      //
// PARAMETERS                                                           //
//   NONE                                                               //
//                                                                      //
// RETURNS                                                              //
//   0 : la version de l'application est incorrect                      //
//   1 : OK                                                             //
//**********************************************************************//
function Init() {
	var nRet, strFilter;

	// Recherche de l'utilisateur
	nRet = GetLoggedUser();
	if (nRet != 0)
		return nRet;
	
	// on a trouv l'utilisateur ou utilisateur anonyme
	RSUtilisateur.Movefirst();
	
	if (RSUtilisateur.Fields.Item("Locked").Value != 0) {
		msgcode = Application("userAccountLocked");
		WriteToLog("Init","End", Session.SessionID, User+" - account locked","","");
		return 1; // Not Ok
	}
	
	// Rcupration des infos sur l'utilisateur
	Session("IDUSER")		= RSUtilisateur.Fields.Item("IDUSER").Value;
	Session("vicuser")		= RSUtilisateur.Fields.Item("VICUser").Value;
	Session("vicpassword")	= RSUtilisateur.Fields.Item("VICPassword").Value;
	Session("language")		= RSUtilisateur.Fields.Item("Langue").Value;
	Session("Description")	= RSUtilisateur.Fields.Item("Description").Value;
	Session("locked")		= RSUtilisateur.Fields.Item("Locked").Value;
	Session("TIES")			= RSUtilisateur.Fields.Item("TIES").Value;
	Session("Private")		= RSUtilisateur.Fields.Item("Private").Value;
	Session("Certificat")	= RSUtilisateur.Fields.Item("Certificat").Value;
	
	if (Session("vicuser") == "") {
		Session("user")		= Application("GenUser");
		Session("password")	= Application("GenPassword");
	}
	else {
		Session("user")		= RSUtilisateur.Fields.Item("UserName").Value;
		Session("password")	= RSUtilisateur.Fields.Item("Password").Value;
	}

	// Rcupration des droits d'accs aux services
	// tous groupes confondus : droit = 'ToutService' le plus important	
	RSToutServ = GetRecord("RQToutServ", Array(1,Session("IDUSER")),"");
	if (RSToutServ == null) {// ODBC error
		msgcode = Application("sysProfil");
		return -1;
	}		
	Session("toutservice") = 0;
	if (!RSToutServ.BOF) {
		RSToutServ.MoveFirst();
		Session("toutservice") = RSToutServ.Fields.Item("ToutService").Value;
	}		
		 		
	// rcupration du groupe de l'utilisateur
	// groupe = groupe d'imputation s'il existe, sinon
	// groupe = groupe au niveau d'Admin le plus important (cf. requte suivante)	
	RSGroup = GetRecord("RQGroup", Array(1,Session("IDUSER")),"");
	if (RSGroup == null) {// ODBC error
		msgcode = Application("sysProfil");
		return -1;
	}
	if (!RSGroup.BOF) {
		RSGroup.MoveFirst();
		Session("IDPROF")	= RSGroup.Fields.Item("IDPROF").Value;
		Session("Group")	= RSGroup.Fields.Item("NomProfil").Value;
		Session("Appelante")= RSGroup.Fields.Item("Appelante").Value;
	}
	
	// Rcupration du Niveau d'administration de l'utilisateur
	// tous groupes confondus : droit = 'Admin' le plus important
	RSProfil = GetRecord("RQAdmin", Array(1,Session("IDUSER")),"");
	if (RSProfil == null) {// ODBC error
		msgcode = Application("sysProfil");
		return -1;
	}				
		
	Session("level") = 0;
	Session("IDGROUP") = Session("IDPROF");	
	if (!RSProfil.BOF) {
		RSProfil.MoveFirst();
		Session("level")	= RSProfil.Fields.Item("Admin").Value;
		Session("IDGROUP")	= RSProfil.Fields.Item("IDPROF").Value;
		Session("Appelee")	= RSProfil.Fields.Item("Appelee").Value;
		
		// si l'on a pas trouv de groupe d'imputation, alors ce groupe
		// sert de rfrence pour la ventilation
		if (RSGroup.BOF) {			
			Session("IDPROF")	= RSProfil.Fields.Item("IDPROF").Value;
			Session("Group")	= RSProfil.Fields.Item("NomProfil").Value;
			Session("Appelante")= "";
		}		
	}

	Application.Lock();
	
	//rcupration des infos des groupes de l'utilisateur
	AGroupInfos = new Array();
	EmulUser = "_EMUL_USER_"+ Session("IDUSER");
	Application(EmulUser) = "";
	
	// Rcupration des quotas des groupes de l'utilisateur pour chaque
	// mulateur
	PalierMax = -1;
	RSGroup = GetRecord("RQGroup", Array(1,Session("IDUSER")),"");
	if (RSGroup == null) {// ODBC error
		msgcode = Application("sysProfil");
		return -1;
	}
	if (!RSGroup.BOF) {
		i = 0;
		strGroup = "";
		while (!RSGroup.EOF) {
			if (i>0)
				strGroup += ",";
			strGroup += RSGroup.Fields.Item("IDPROF").Value;
			
			strInfos = "";
			strInfos += "\n[GROUP]";
			strInfos += "\n" + "IDPROF=" + RSGroup.Fields.Item("IDPROF").Value;
			strInfos += "\n" + "IDSVR=" + RSGroup.Fields.Item("IDSVR").Value;
			strInfos += "\n" + "NomProfil=" + RSGroup.Fields.Item("NomProfil").Value;
			strInfos += "\n" + "Description=" + RSGroup.Fields.Item("Description").Value;
			strInfos += "\n" + "HeureDeb=" + RSGroup.Fields.Item("HeureDeb").Value;
			strInfos += "\n" + "HeureFin=" + RSGroup.Fields.Item("HeureFin").Value;
			strInfos += "\n" + "DureeMax=" + RSGroup.Fields.Item("DureeMax").Value;
			strInfos += "\n" + "Admin=" + RSGroup.Fields.Item("Admin").Value;
			strInfos += "\n" + "DefUser=" + RSGroup.Fields.Item("DefUser").Value;
			strInfos += "\n" + "DefService=" + RSGroup.Fields.Item("DefService").Value;
			strInfos += "\n" + "ToutService=" + RSGroup.Fields.Item("ToutService").Value;
			strInfos += "\n" + "Appelante=" + RSGroup.Fields.Item("Appelante").Value;
			strInfos += "\n" + "Appelee=" + RSGroup.Fields.Item("Appelee").Value;
			strInfos += "\n" + "Imputation=" + RSGroup.Fields.Item("Imputation").Value;
			strInfos += "\n" + "PalierMax=" + RSGroup.Fields.Item("PalierMax").Value;
			strInfos += "\n" + "DefEmul=" + RSGroup.Fields.Item("DefEmul").Value;
			strInfos += "\n" + "TIES=" + RSGroup.Fields.Item("TIES").Value;
			strInfos += "\n" + "strCvs=" + RSGroup.Fields.Item("strCvs").Value;
			AGroupInfos[i] = strInfos;
			
			PalierMax = Math.max(PalierMax,RSGroup.Fields.Item("PalierMax").Value);
			
			RSGroup.MoveNext();
			i++;
		}		
		Session("PalierMax") = PalierMax;
		
		if (strGroup != "") {			
			AGroup = strGroup.split(",");
			len = AGroup.length;
			ANbMax = new Array();
			strMax = "";
			//EmulUser = "_EMUL_USER_"+ Session("IDUSER");

			//quotas par dfaut pour chaque mulateur
			for (i=0;i<len;i++) {			
				IDPROF = AGroup[i];			
									
				strFilter = "(Allow = 1)";
				RSEmul = GetRecord("RQEmulT",null,strFilter);
				if ((RSEmul != null) && (!RSEmul.BOF)) {
					while (!RSEmul.EOF) {
						IDEMUL = RSEmul.Fields.Item("IDEMUL").Value;
								
						QuotaGrp = "Q_EMUL_"+ IDEMUL + "_GRP_" + IDPROF;
						QuotaUser = "Q_EMUL_"+ IDEMUL + "_GRP_" + IDPROF + "_USER_" + Session("IDUSER");
						
						Application(QuotaGrp) = RSEmul.Fields.Item("CvGrp").Value;
						Application(QuotaUser) = RSEmul.Fields.Item("CvUser").Value;
								
						ANbMax[IDEMUL] = Application(QuotaUser);
						RSEmul.MoveNext();
					}
				}
				else {
					msgcode = Application("sysEmul");
					return -1;
				}			
			}
			
			// rcupration des quotas dfinis pour chaque groupe
			count = 0;
			for (i=0;i<len;i++) {			
				IDPROF = AGroup[i];			
				strMax = "";
				strFilter = "IDPROF="+IDPROF;
				RSSession = GetRecord("RQSessionT",null,strFilter);
				if ((RSSession != null) && (!RSSession.BOF)) {
					count++;
					while (!RSSession.EOF) {						
						IDEMUL = RSSession.Fields.Item("IDEMUL").Value;
						QuotaGrp = "Q_EMUL_"+ IDEMUL + "_GRP_" + IDPROF;
						QuotaUser = "Q_EMUL_"+ IDEMUL + "_GRP_" + IDPROF + "_USER_" + Session("IDUSER");
						if (RSSession.Fields.Item("TotGrp").Value != -1)
							Application(QuotaGrp) = RSSession.Fields.Item("TotGrp").Value;							
						
						if (RSSession.Fields.Item("TotUser").Value != "-1") {
							Application(QuotaUser) = RSSession.Fields.Item("TotUser").Value;
							
							//if (ANbMax[IDEMUL] == null)
							if (count == 1)
								ANbMax[IDEMUL] = Application(QuotaUser);
							else
								ANbMax[IDEMUL] = Math.max(ANbMax[IDEMUL],Application(QuotaUser));
						}
						
						if (strMax != "")
							strMax += ",";
						strMax += IDEMUL;
						
						RSSession.MoveNext();
					}
				}
				
				// remember max of emulators user can access
				if (i == 0)
					Application(EmulUser) = strMax;
				else
					Application(EmulUser) = ((strMax.length > (Application(EmulUser)).length) ? strMax:Application(EmulUser));
			}
						
			// finally override User quota with the maximum found for its group
			strEmuls = Application("Emuls");
			if (strEmuls != "") {
				AEmuls = strEmuls.split(",");
				for (i=0;i<AEmuls.length;i++) {
					QuotaUser = "Q_EMUL_"+ AEmuls[i] + "_GRP_" + Session("IDGROUP") + "_USER_" + Session("IDUSER");
					nb = ANbMax[AEmuls[i]];
					Application(QuotaUser) = ANbMax[AEmuls[i]];
				}
			}
		}
	}	

	if (Application(EmulUser) == "")
		Application(EmulUser) = Application("Emuls");

	Application.UnLock();
	
	level = Session("level"); //(0: user; 1: Admin read; 2: Admin read/write)
	
	// Dtermine le niveau de fonctionnalits de l'utilisateur
	Session("LOGIN") = 3; // fonc. de base User
	if (level > 0) {
		Session("LOGIN") = 2; // fonc. d'Admin
		if ((level >= 2) && (Session("IDSVR") == 1))
			Session("LOGIN") = 1; // fonc. de Super Admin (Admin du serveur primaire)
	}

	// infos utilisateur pour application java
	AUserInfos = new Array();
	AUserInfos[0] = "[USER]\n";
	AUserInfos[1] = "IDUSER="+ Session("IDUSER")+ "\n";
	AUserInfos[2] = "IDSVR="+ Session("IDSVR")+ "\n";
	AUserInfos[3] = "VICUser="+ Session("vicuser")+ "\n";
	AUserInfos[4] = "UserName="+ Session("user") + "\n";
	AUserInfos[5] = "Password="+ Session("password") + "\n";
	AUserInfos[6] = "Description="+ Session("Description")+ "\n";
	AUserInfos[7] = "VICPassword="+ Session("vicpassword")+ "\n";
	AUserInfos[8] = "Langue="+ "French" + "\n";
	AUserInfos[9] = "Locked="+ Session("locked")+ "\n";
	AUserInfos[10] = "TIES="+ Session("TIES")+ "\n";
	AUserInfos[11] = "Private="+ Session("Private")+ "\n";
	AUserInfos[12] = "Certificat="+ Session("Certificat")+ "\n";
	AUserInfos[13] = "login="+ Session("LOGIN")+ "\n";
	AUserInfos[14] = "droit="+ Session("droit")+ "\n";
	AUserInfos[15] = "level="+ Session("level")+ "\n";
	AUserInfos[16] = "toutservice="+ Session("toutservice")+ "\n";
	AUserInfos[17] = "PalierMax="+ Session("PalierMax")+ "\n";
	AUserInfos[18] = "Appelee="+ Session("Appelee")+ "\n";
	AUserInfos[19] = "Appelante="+ Session("Appelante")+ "\n";
	AUserInfos[20] = "IDPROF="+ Session("IDPROF")+ "\n";
	AUserInfos[21] = "IDGROUP="+ Session("IDGROUP")+ "\n";	
	AUserInfos[22] = "EMULS="+ Application(EmulUser)+ "\n";
	AUserInfos[23] = "Group="+ Session("Group") + "\n";
	AUserInfos[24] = "SessionID="+ Session.SessionID + "\n";
	
	// Ok
	return 0;
	
}

function GetLoggedUser() {

	var ADom, GNames, AGIDs, AUser, strFilter, len, i;
	var AAuth, AuthUser;
	
	bDName = false;
	bNTUser = false;
	bLDAPUser = false;
	bAuthenticate = false;
	
	// case TIES user
	if (Session("fromlogin") == "1") {
		User = Session("user");
	}
	// case NT or LDAP user
	else {
		/*if ((Application("Platform").toUpperCase() != "WINDOWS") ||
			(Application("WebServer").toUpperCase() != "IIS")) {				
				msgcode = Application("admPlatformWeb");
				return 1; // not Ok
		}*/

		User = Session("user");
		// case NT user
		if (Application("NtGroupe") == 1) {
			bNTUser = true;
			bLDAPUser = ((Application("LdapGroupe") == 1)? true:false);
		
			User = Request.ServerVariables("LOGON_USER").Item;
			if (User == "") {
				User = Request.ServerVariables("REMOTE_USER").Item;
				if (User == "") {
					User = Request.ServerVariables("AUTH_USER").Item;
				}
			}
		}
		
		// case LDAP User
		if (Application("LdapGroupe") == 1) {
			// s'il existe des Roots LDAP dclars
			strFilter = "IDSVR="+Session("IDSVR");
			RSLdap = GetRecord("RQLdapT",null,strFilter);
			if ((RSLdap != null) && (!RSLdap.BOF)) {
				if (Session("user") == "") {				
					if (User == "") {
						if (Application("WebServer") == "APACHE") {
							bNTUser = false;
							bLDAPUser = true;
							bAuthenticate = true;
							AuthUser = Request.ServerVariables("AUTH_USER").Item;
							User = (AuthUser == null ? "" : AuthUser);
							AuthPassword = Request.ServerVariables("AUTH_PASSWORD").Item;
							AuthPassword = (AuthPassword == null ? "" : AuthPassword);
							Session("user") = User;
							Session("password") = AuthPassword;
						}
						else {
							AAuth = Request.ServerVariables("HTTP_Authorization").Item;
							AAuth = ((AAuth == null)?"":AAuth);

							if (AAuth != "") {
								AAuth = AAuth.split(" ");
								Type = AAuth[0];
								AuthUser = AAuth[1];
									
								if (Application("iASP") == 1) {
									Base64 = Server.CreateObject("com.twinsoft.util.Base64");
								}
								else {
									Base64 = Server.CreateObject("Base64");
								}
								if (Base64 != null) {
									AuthUser = Base64.myString(AuthUser);
									AuthUser = AuthUser.split(":");
									Base64 = null;

									bNTUser = false;
									bLDAPUser = true;
									bAuthenticate = true;
									User = AuthUser[0];
									Session("user") = User;
									Session("password") = AuthUser[1];
								}
							}
						}
					}
					
					if (User == "") {
						str = Request.ServerVariables("HTTP_Authorization").Item;
						Response.Status = "401 Unauthorized";
						Response.AddHeader("WWW-Authenticate","basic realm=");
						Response.End();
					}
				}
				// Temporary case
				else if (Session("LDAP_Apache") == 1) {
					bNTUser = false;
					bLDAPUser = true;
					bAuthenticate = true;
					User = Session("user");
				}
				// case LDAP Novel
				else {
					bNTUser = false;
					bLDAPUser = true;
					bDName = true;
					Session("Novell") = true;
					User = Session("user");
				}
			}
		}		
	}
	
	if (bNTUser) {	
		User = ReplaceChar(User, '\\', '/');
		ADom = User.split("/");
		Session("NTUser") = User;
		Session("Domain") = ADom[0];
		Session("NT2000User") = ADom[1];
	}
	
	if (bLDAPUser) {
		Session("LDAPUser") = User;
		
		// rcupration des Roots LDAP
		AdsPaths = "";
		strFilter = "IDSVR="+Session("IDSVR");
		RSLdap = GetRecord("RQLdapT",null,strFilter);
		if (RSLdap == null) {
			msgcode = Application("sysLDAP");
			return -1; // ODBC error
		}
		if (!RSLdap.BOF) {
			while (!RSLdap.EOF) {
				if (AdsPaths == "")
					AdsPaths = RSLdap.Fields.Item("ADsPath").Value;
				else
					AdsPaths += "|" + RSLdap.Fields.Item("ADsPath").Value;
				
				RSLdap.MoveNext();
			}
		}
		else {
			//msgcode = Application("admLdapServer");
			//return 1; // Not Ok!
			bLDAPUser = false;
		}
	}
	
	Session("vicuser")		= User;
	Session("vicuserfull")	= User;
	Session("vicpassword")	= Session("password");
	
	// append User name to log file
	WriteToLog("Init","Enter", Session.SessionID, User,"","");
		
	// Requte Utilisateur	
	/* NH
	RSUtilisateur = GetRecord("RQTIESUserByName", Array(2,Session("IDSVR"),User),"");
	if (RSUtilisateur == null) {
		msgcode = Application("sysUser");
		return -1; // ODBC error
	}*/
	if (Session("fromlogin") == "1") {
		RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,1),"");
		if (RSUtilisateur == null) {
			msgcode = Application("sysUser");
			return -1; // ODBC error
		}
	}
	
	// NT user : recherche des groupes et insertion si ncessaire
	if (bNTUser && (User != "")) {
		RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,2),"");
		if (RSUtilisateur == null) {
			msgcode = Application("sysUser");
			return -1; // ODBC error
		}

		if (RSUtilisateur.BOF)
			IDUSER = 0;
		else
			IDUSER = RSUtilisateur.Fields.Item(0).Value;
			
		// rcupration des groupes via ADSI
		GNames = GetNTGroups(User);		
		if (GNames != "") {
			AGIDs = new Array();
			i = 0;
			// rcupration des groupes TIES bass sur NT
			strFilter = "(IDSVR="+ Session("IDSVR")+") AND (TIES=2)";
			RSProfil = GetRecord("RQProfil",Array(1,GNames),strFilter);
			if ((RSProfil != null) && (!RSProfil.BOF)) {
				RSProfil.MoveFirst();
				while (!RSProfil.EOF) {
					AGIDs[i] = RSProfil.Fields.Item("IDPROF").Value;					
					RSProfil.MoveNext();
					i++;
				}
					
				len = AGIDs.length;
				if (len > 0) {
					if (IDUSER == 0) {
						// Insertion du User dans TAS_UTILISATEUR (TIES=2)					
						AUser = GetUserInfos(User);
						if ((AUser == null) || (!IsExecCmd("RQNewUser",AUser.toArray(),""))) {
							msgcode = Application("sysUser");
							return -1; // ODBC error
						}					
							
						// rcupration de l'Id du user insr	
						/*NH
						RSUtilisateur = GetRecord("RQTIESUserByName", Array(2,Session("IDSVR"),User),"");
						if ((RSUtilisateur == null) || (RSUtilisateur.BOF)) {
							msgcode = Application("sysUser");
							return -1; // ODBC error
						}*/
						RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,2),"");
						if (RSUtilisateur == null) {
							msgcode = Application("sysUser");
							return -1; // ODBC error
						}
						
						RSUtilisateur.MoveLast();
						IDUSER = RSUtilisateur.Fields.Item(0).Value;
					}
					else {
						// supression des relations NT dans TAS_PROFUSR
						AIDList = "0";
						RSList = GetRecord("RQDeleteNT1",Array(1,IDUSER),"");
						if ((RSList != null) && (!RSList.BOF)) {
							while (!RSList.EOF) {
								IDLIST = RSList.Fields.Item("IDPROFUSR").Value;
								AIDList += "," + IDLIST;
								RSList.MoveNext();
							}
						}
						/*NH
						if (!IsExecCmd("RQDeleteNT",Array(1,IDUSER),"")) {*/
						if (!IsExecCmd("RQDeleteNT2",Array(1,AIDList),"")) {
							msgcode = Application("sysProfusr");
							return -1;
						}
					}
											
					// Insertion des relations NT dans TAS_PROFUSR					
					for (i=0;i<len;i++) {
						if (!IsExecCmd("RQNewProfUsr",Array(2,IDUSER,AGIDs[i]),"")) {
							msgcode = Application("sysProfusr");
							return -1;
						}
					}
				}
			}
				
			// Requte Utilisateur	
			/*NH
			RSUtilisateur = GetRecord("RQTIESUserByName", Array(2,Session("IDSVR"),User),"");
			if (RSUtilisateur == null) {
				msgcode = Application("sysUser");
				return -1; // ODBC error
			}*/
			RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,2),"");
			if (RSUtilisateur == null) {
				msgcode = Application("sysUser");
				return -1; // ODBC error
			}			
		}
	}
	
	// LDAP user : recherche des groupes et insertion si ncessaire
	if (bLDAPUser && (User != "")) {
		/*
		RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,3),"");
		if (RSUtilisateur == null) {
			msgcode = Application("sysUser");
			return -1; // ODBC error
		}
		
		if (RSUtilisateur.BOF)
			IDUSER = 0;
		else
			IDUSER = RSUtilisateur.Fields.Item(0).Value;*/
		
		// perform an LDAP autentification on possible Windows2000 server
		if (bNTUser && (Session("NTUser") != "")) {
			User = Session("NT2000User");		
		}
		
		if (AdsPaths != "") {			
			// rcupration des groupes via ADSI
			GNames = GetLDAPGroups(User,AdsPaths);
			if (GNames == null) {
				msgcode = Application("userAccessForbidden");
				WriteToLog("Init","End", Session.SessionID, User+" - access denied","","");
				return 1; // Not Ok
			}
					
			if (GNames != "") {
				RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,3),"");
				if (RSUtilisateur == null) {
					msgcode = Application("sysUser");
					return -1; // ODBC error
				}
		
				if (RSUtilisateur.BOF)
					IDUSER = 0;
				else
					IDUSER = RSUtilisateur.Fields.Item(0).Value;
			
				AGIDs = new Array();
				i = 0;
				
				// rcupration des groupes TIES bass sur LDAP
				strFilter = "(IDSVR="+ Session("IDSVR")+") AND (TIES=3)";
				RSProfil = GetRecord("RQDesc",Array(1,GNames),strFilter);
				if ((RSProfil != null) && (!RSProfil.BOF)) {
					RSProfil.MoveFirst();
					while (!RSProfil.EOF) {
						AGIDs[i] = RSProfil.Fields.Item("IDPROF").Value;					
						RSProfil.MoveNext();
						i++;
					}
					
					len = AGIDs.length;
					if (len > 0) {
						if (IDUSER == 0) {
							// Insertion du User dans TAS_UTILISATEUR (TIES=3)					
							AUser = Array(11,Session("IDSVR"),User,"ZXNET1","DEMFTD",UserDN,"","francais",0,3,"","Client.cer");
							if ((AUser == null) || (!IsExecCmd("RQNewUser",AUser,""))) {
								msgcode = Application("sysUser");
								return -1; // ODBC error
							}					
								
							// rcupration de l'Id du user insr	
							/*NH
							RSUtilisateur = GetRecord("RQTIESUserByName", Array(2,Session("IDSVR"),User),"");
							if ((RSUtilisateur == null) || (RSUtilisateur.BOF)) {
								msgcode = Application("sysUser");
								return -1; // ODBC error
							}*/
							RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,3),"");
							if (RSUtilisateur == null) {
								msgcode = Application("sysUser");
								return -1; // ODBC error
							}
							
							RSUtilisateur.MoveLast();
							IDUSER = RSUtilisateur.Fields.Item(0).Value;
						}
						else {
							// supression des relations LDAP dans TAS_PROFUSR
							/*NH */							
							AIDList = "0";
							RSList = GetRecord("RQDeleteLDAP1",Array(1,IDUSER),"");
							if ((RSList != null) && (!RSList.BOF)) {
								while (!RSList.EOF) {
									IDLIST = RSList.Fields.Item("IDPROFUSR").Value;
									AIDList += "," + IDLIST;
									RSList.MoveNext();
								}
							}
							/*NH
							if (!IsExecCmd("RQDeleteLDAP",Array(1,IDUSER),"")) {*/
							if (!IsExecCmd("RQDeleteLDAP2",Array(1,AIDList),"")) {
								msgcode = Application("sysProfusr");
								return -1;
							}
						}
												
						// Insertion des relations LDAP dans TAS_PROFUSR					
						for (i=0;i<len;i++) {
							if (!IsExecCmd("RQNewProfUsr",Array(2,IDUSER,AGIDs[i]),"")) {
								msgcode = Application("sysProfusr");
								return -1;
							}
						}
					}
				}
					
				// Requte Utilisateur	
				/*NH
				RSUtilisateur = GetRecord("RQTIESUserByName", Array(2,Session("IDSVR"),User),"");
				if (RSUtilisateur == null) {
					msgcode = Application("sysUser");
					return -1; // ODBC error
				}*/
				RSUtilisateur = GetRecord("RQTIESUserByName", Array(3,Session("IDSVR"),User,3),"");
				if (RSUtilisateur == null) {
					msgcode = Application("sysUser");
					return -1; // ODBC error
				}
			}
			else {
				bLDAPUser = false;
			}
		}
	}

	// Requte Anonyme
	//NH if (RSUtilisateur.BOF)
	if ((RSUtilisateur == null) || ((RSUtilisateur != null) && (RSUtilisateur.BOF)))
		return GetAnon();
		
	// Vrifie que le mot de passe est correct si l'utilisateur a t trouv
	if (!bNTUser && !bLDAPUser) {
		RSUtilisateur.MoveFirst();		
		db_password = RTrimSpace(RSUtilisateur.Fields.Item("VICPassword").Value);
			
		if (db_password != Session("vicpassword")) {
			msgcode = Application("userInvalidPwd");
			WriteToLog("Init","End", Session.SessionID, User+" - invalid password","","");
			return 1; // not Ok
		}
			
		Session("droit") = 0;
	}
	else {
		if (bNTUser)
			Session("droit") = 2; // groupe NT
		if (bLDAPUser) {
			Session("droit") = 3; // groupe LDAP
			if (bNTUser) {// NT2000
				if (User == Session("NT2000User")) {
					if (Session("vicuser") == Session("NTUser")) {
						Session("vicuser")		= User;
						Session("vicuserfull")	= User;					
					}
				}
			}
		}
	}

	WriteToLog("Init","End", Session.SessionID, User+" - access granted","","");
	
	return 0; // Ok
}

function GetAnon()
{
	RSUtilisateur = GetRecord("RQAnon",Array(1,Session("IDSVR")),"");
		
	if (RSUtilisateur == null) {
		msgcode = Application("sysUser");
		return -1; // ODBC error
	}
	
	if (RSUtilisateur.BOF) {
		msgcode = Application("userAccessForbidden");
		WriteToLog("Init","End", Session.SessionID, User+" - access denied","","");
		return 1; // Not Ok
	}
	
	RSUtilisateur.Movefirst();
	if (Session("vicuserfull") == "")
		Session("vicuserfull") = RSUtilisateur.Fields.Item("VICUser").Value;
	
	Session("droit") = 1;	// Anonyme

	WriteToLog("Init","End", Session.SessionID, User+" - anonymous access granted","","");
		
	return 0; // Ok
}
</SCRIPT>
<SCRIPT LANGUAGE=VBScript RUNAT=Server>
Function GetNTGroups(User)

	Dim Names, APath
	
	Names = ""
	Err.Clear
	
	If (User <> "") Then
		On Error Resume Next
		Set ADSUser = GetObject("WinNT://"+User)
		If Err.number <> 0 Then
			CatchError
		Else
			For Each Group in ADSUser.Groups
				APath = Split(Group.ADsPath,"//")
				If (Names = "") Then
				Names = "'" + APath(1) + "'"
				Else
					Names = Names + "," + "'" + APath(1) + "'"
				End If
			Next
			
			Set ADSUser = Nothing
		End If
	End If
	
	GetNTGroups = Names
	
End Function
Function GetUserInfos(User)

	Dim Infos, Desc, Locked
	
	Err.Clear
	If (User <> "") Then
		On Error Resume Next
		Set ADSUser = GetObject("WinNT://"+User)
		If Err.number <> 0 Then
			CatchError
			GetUserInfos = Nothing
		Else
			Desc = ADSUser.FullName
			If (ADSUser.IsAccountLocked = true) Then
				Locked = 1
			Else
				Locked = 0
			End If
	
			Infos = Array(11,Session("IDSVR"),User,"ZXNET1","DEMFTD",Desc,"","francais",Locked,2,"","Client.cer")
	
			Set ADSUser = Nothing
			GetUserInfos = Infos
		End If
	Else
		GetUserInfos = Nothing
	End If		
	
End Function

Function GetLDAPGroups(User, strRoots)

	Dim Conn, Cmd, RS, strUserRoot, strPwd, iStart, index, iFirst, iSec
	Dim Names, strPath, strGrp, strDN, ARoot, APath, strOU, strAdsPath
	
	UserDN = User
	strUserRoot = ""
	strPath = ""
	strDN = ""
	Names = ""
	Err.Clear
	
	If (strRoots <> "") Then
		ARoot = Split(strRoots,"|")		
		
		If (User <> "") Then			
			If Application("iASP") = 1 then
				Set twsLDAP = Server.CreateObject("com.twinsoft.util.TWSLDAP")

				Dim attributes, posSlash, host, port, searchBase, filter

				For Each strRoot In ARoot
					Domain = Replace(strRoot, "LDAP://", "")
					Domain = Replace(Domain, "ldap://", "")
				
					posSlash = InStr(Domain, "/")
					If posSlash = 0 then
						host = Domain
						searchBase = ""
					Else
						host = Mid(Domain, 1, posSlash - 1)
						searchBase = Mid(Domain, posSlash + 1)
					End if
					port = 389
					attributes = Array("dn")

					If bDName = False Then
						filter = "(|(uid="+ User +")(&(objectClass=user)(sAMAccountName="+ User +")))"
						twsLDAP.search host, port, searchBase, filter, attributes
						If twsLDAP.errorId = 0 then
							strPath = ""
							result = "LDAP://" + host + "/" + twsLDAP.getNextResult() + "," + searchBase
							If Session("NTUser") <> "" Then
								While (twsLDAP.hasMoreResults())
									If twsLDAP.errorId = 0 then
										strAdsPath = UCase(result)
										iFirst = InStr(strAdsPath,"DC=")
										If iFirst <> 0 Then
											strAdsPath = Mid(strAdsPath,iFirst+3)
											iSec = InStr(strAdsPath,",DC=")
											If iSec <> 0 Then
												strDomain = Mid(strAdsPath,1,iSec-1)
											Else
												strDomain = strAdsPath
											End If
												
											If strDomain = UCase(Session("Domain")) Then
												strPath = result
											End If
										End If
										result = "LDAP://" + host + "/" + twsLDAP.getNextResult() + "," + searchBase
										'result = twsLDAP.getNextResult()
									Else
										CatchError
									End if
								Wend
							Else
								strPath = result
							End If
						Else	
							CatchError
						End If
					Else
						strPath = "/" + User
					End If
		
					strUserRoot = strRoot
								
					If (strPath <> "") Then
						'NH
						'WriteToLog "LDAP User:",strPath, 0,"","",""
							
						index = InStrRev(strPath,"/")
						If (index <> 0) Then
							strDN = Mid(strPath,index+1)
							strPwd = Session("password")
							UserDN = strDN
							'NH
							'WriteToLog "LDAP UserDN:",strDN, 0,"","",""
								
							iStart = 1
							strOU = UserDN
							strOU = Replace(strOU,",","/",1,-1)
							Do
								index = InStr(iStart,LCase(strOU),"ou=")
								If (index <> 0) Then
									strOU = Mid(strOU,index)											
									If (Names = "") Then
										Names = "'" & strOU & "'"
									Else
										Names = Names & "," & "'" & strOU & "'"
									End If
									iStart = 3
								Else
									Exit Do
								End If									
							Loop
										
							filter = "(|(|(&(objectClass=groupOfUniqueNames)(uniqueMember="+ strDN +"))(&(objectClass=groupOfNames)(member="+ strDN +")))(&(objectClass=group)(Member="+ strDN +")))"
							twsLDAP.search host, port, searchBase, filter, attributes
							If twsLDAP.errorId = 0 then
								While (twsLDAP.hasMoreResults())
									result = "LDAP://" + host + "/" + twsLDAP.getNextResult() + "," + searchBase
									If twsLDAP.errorId = 0 then
										APath = result
										'NH
										'WriteToLog "LDAP UserGrp:",APath, 0,"","",""
											
										APath = Replace(APath,"LDAP://","")
										APath = Split(APath,"/")
													
										strGrp = APath(1)
										strGrp = Replace(strGrp,",","/",1,-1)

										iStart = 1
										Do
											index = InStr(iStart,LCase(strGrp),"cn=")
											If (index <> 0) Then
												strGrp = Mid(strGrp,index)											
												If (Names = "") Then
													Names = "'" & strGrp & "'"
												Else
													Names = Names & "," & "'" & strGrp & "'"
												End If
												iStart = 3
											Else
												Exit Do
											End If									
										Loop
									Else
										CatchError
									End if
								Wend
							Else
								CatchError
							End if
						End if
					End if
				Next
					
				If strDN <> "" Then
					bLDAPUser = True				
					If bAuthenticate = True Then
						'Now try to bind User
						If (strUserRoot <> "") Then
							If (twsLDAP.bind(host, port, strDN, strPwd) = true) then
								filter = "(|(uid="+ User +")(&(objectClass=user)(sAMAccountName="+ User +")))"
								twsLDAP.search host, port, searchBase, filter, attributes
								If twsLDAP.errorId <> 0 then
									CatchError
									Names = Null
								End If
							Else
								CatchError
								Names = Null
							End If
						End If
					End If
				Else
					bLDAPUser = False
				End If
			' Using ADSI object
			Else
				Set Conn = Server.CreateObject("ADODB.Connection")
				Conn.Provider = "ADsDSOObject"
				On Error Resume Next
				Conn.Open("ADs Provider")
				If Err.number <> 0 Then
					CatchError
				'	Names = Null
				Else
					Set Cmd = Server.CreateObject("ADODB.Command")			
					Cmd.ActiveConnection = Conn
					
					For Each strRoot In ARoot
						If bDName = False Then
							Cmd.CommandText = "<" + strRoot + ">;(|(uid="+ User +")(&(objectClass=user)(sAMAccountName="+ User +")));AdsPath;subtree"
							On Error Resume Next
							Set RS = Cmd.Execute()
							If Err.number <> 0 Then
								CatchError
							'	Names = Null
							Else
								strPath = ""
								If Not RS.BOF Then								
									If Session("NTUser") <> "" Then
										While (Not RS.EOF)									
											strAdsPath = UCase(RS.Fields("AdsPath").Value)
											iFirst = InStr(strAdsPath,"DC=")
											If iFirst <> 0 Then
												strAdsPath = Mid(strAdsPath,iFirst+3)
												iSec = InStr(strAdsPath,",DC=")
												If iSec <> 0 Then
													strDomain = Mid(strAdsPath,1,iSec-1)
												Else
													strDomain = strAdsPath
												End If
												
												If strDomain = UCase(Session("Domain")) Then
													strPath = RS.Fields("AdsPath").Value
												End If
											End If
											RS.MoveNext()
										Wend
									Else
										strPath = RS.Fields("AdsPath").Value
									End If
								End If
							End If
						Else
							strPath = "/" + User
						End If
							
						strUserRoot = strRoot
								
						If (strPath <> "") Then
							'NH
							'WriteToLog "LDAP User:",strPath, 0,"","",""
							
							index = InStrRev(strPath,"/")
							If (index <> 0) Then
								strDN = Mid(strPath,index+1)
								strPwd = Session("password")
								UserDN = strDN
								'NH
								'WriteToLog "LDAP UserDN:",strDN, 0,"","",""
								
								iStart = 1
								strOU = UserDN
								strOU = Replace(strOU,",","/",1,-1)
								Do
									index = InStr(iStart,LCase(strOU),"ou=")
									If (index <> 0) Then
										strOU = Mid(strOU,index)											
										If (Names = "") Then
											Names = "'" & strOU & "'"
										Else
											Names = Names & "," & "'" & strOU & "'"
										End If
										iStart = 3
									Else
										Exit Do
									End If									
								Loop
										
								Cmd.CommandText = "<" + strRoot + ">;(|(|(&(objectClass=groupOfUniqueNames)(uniqueMember="+ strDN +"))(&(objectClass=groupOfNames)(member="+ strDN +")))(&(objectClass=group)(Member="+ strDN +")));AdsPath;subtree"
								On Error Resume Next
								Set RS = Cmd.Execute()
								If Err.number <> 0 Then
									CatchError
									'Names = Null
								Else
									If Not RS.BOF Then
										While (Not RS.EOF)
											APath = RS.Fields("AdsPath").Value
											'NH
											'WriteToLog "LDAP UserGrp:",APath, 0,"","",""
											
											APath = Replace(APath,"LDAP://","")
											APath = Split(APath,"/")
													
											strGrp = APath(1)
											strGrp = Replace(strGrp,",","/",1,-1)

											iStart = 1
											Do
												index = InStr(iStart,LCase(strGrp),"cn=")
												If (index <> 0) Then
													strGrp = Mid(strGrp,index)											
													If (Names = "") Then
														Names = "'" & strGrp & "'"
													Else
														Names = Names & "," & "'" & strGrp & "'"
													End If
													iStart = 3
												Else
													Exit Do
												End If									
											Loop
													
											RS.MoveNext()
										Wend
									End If
								End If
							End If
						End If
						'End If
					Next
					
					If strDN <> "" Then
						bLDAPUser = True				
						If bAuthenticate = True Then
							'Now try to bind User
							If (strUserRoot <> "") Then
								If (Conn <> Empty) Then
									If (DBConn.State <> 0) Then
										Conn.Close
									End If
								End If
								On Error Resume Next
								Conn.Open "ADs Provider",strDN,strPwd
								If Err.number <> 0 Then
									CatchError
									Names = Null
								Else
									Set Cmd = Server.CreateObject("ADODB.Command")			
									Cmd.ActiveConnection = Conn
									'Cmd.CommandText = "<" + strUserRoot + ">;(uid="+ User +");AdsPath;subtree"
									Cmd.CommandText = "<" + strUserRoot + ">;(|(uid="+ User +")(&(objectClass=user)(sAMAccountName="+ User +")));AdsPath;subtree"
									On Error Resume Next
									Set RS = Cmd.Execute()
									If Err.number <> 0 Then
										CatchError
										Names = Null
									End If
								End If
							End If
						End If
					Else
						bLDAPUser = False
					End If
												
					Set RS = Nothing
					Set Cmd = Nothing
				End If
				Set Conn = Nothing			
			End if
		End If
	'Else
	'	Names = Null
	End If
	
	If strDN <> "" Then
		bLDAPUser = True
	Else
		bLDAPUser = False
	End If
		
	GetLDAPGroups = Names
	
End Function
</SCRIPT>

<%		
	var nRet, bDirect, bList, bJava, bFac, PARAM, IDSERV;
	
	PARAM = Request.QueryString.Item;
	Session("application")	= Request.QueryString("application").Item;
	Session("fromlogin")	= Request.QueryString("fromlogin").Item;
	Session("language")		= Request.QueryString("language").Item;
	Session("user")			= Request.QueryString("user").Item;
	Session("password")		= Request.QueryString("password").Item;

	if (Session("user") != null)
		Session("user") = unescape(Session("user"));

	bDirect = Request.QueryString("direct").Item;
	bDirect = ((bDirect == "1")? true:false);
	
	bList = Request.QueryString("list").Item;
	bList = ((bList == "1")? true:false);
	
	bFac = Request.QueryString("fac").Item;
	bFac = ((bFac == "1")? true:false);

	bJava = Request.QueryString("Java").Item;
	bJava = ((bJava == "1")? true:false);

	if (bJava) {
		Session("Java") = true;

		IDSVR = Request.QueryString("IDSVR").Item;
		IDSVR = ((IDSERV == null) ? 1:parseInt(IDSVR,10));
		Session("IDSVR") = IDSVR;
	}
		
	IDSERV = Request.QueryString("IDSERV").Item;
	IDSERV = ((IDSERV == null) ? 0:parseInt(IDSERV,10));

	if (Session("fromlogin") == null)
		Session("fromlogin") = "0";
	
	if (bDirect) {
		if (Session("user") != null)
			Session("fromlogin") = "1";
		else
			Session("user") = "";
	}
	else if (bList) {
		if (Session("user") != null)
			Session("fromlogin") = "1";
		else
			Session("user") = "";
	}
	else if (bFac) {
		if (Session("user") != null)
			Session("fromlogin") = "1";
		else
			Session("user") = "";
	}
	else {
		if (Session("user") == null)
			Session("user") = "";
	}
		
	// Init
	nRet = Init();
	
	// Get Cookies
	strUser = new String(Session("IDUSER"));
	if (strUser != "0") {
		Session("UFrame")	= Request.Cookies(strUser)("UFrame");
		Session("EmulW")	= Request.Cookies(strUser)("EmulW");
		Session("EmulH")	= Request.Cookies(strUser)("EmulH");
		Session("EmulL")	= Request.Cookies(strUser)("EmulL");
		Session("EmulT")	= Request.Cookies(strUser)("EmulT");
	}
	
	switch (nRet) {
		case -1: // ODBC error
		case 1:	 // Not Ok		
			ReleaseODBC();
			if (bJava) {
				Session.Abandon();
				Response.Redirect("../Java/Error.asp?msgcode="+ msgcode + "&errcode=" + errcode +"&errmsg=" + errmsg + "&errcmd=" + errcmd);
			}
			else
				Response.Redirect("../"+ Session("LANG") +"/Error.asp?msgcode="+ msgcode + "&errcode=" + errcode +"&errmsg=" + errmsg + "&errcmd=" + errcmd);
			break;
		case 0: // Ok
		default:
			ReleaseODBC();
			if (bDirect) {
				if (IDSERV == -1) {
					msgcode = Application("admServiceUnknown");
					Response.Redirect("../"+ Session("LANG") +"/Error.asp?msgcode="+ msgcode + "&errcode=" + errcode +"&errmsg=" + errmsg + "&errcmd=" + errcmd);
				}
				else				
					Response.Redirect("../"+ Session("LANG") +"/AccCnx.asp?"+ PARAM);
			}
			else if (bList) {
				Response.Redirect("../"+ Session("LANG") +"/XList.asp?"+ PARAM);
			}
			else if (bFac) {
				Response.Redirect("../"+ Session("LANG") +"/FacLeft.asp?FacUser=1&"+ PARAM);
			}
			else if (!bJava) {
				Response.Redirect("../"+ Session("LANG") +"/Tas.asp?"+ Session("fromlogin")+":"+Session("IDSVR"));
			}
			break;
	}
%>
